// Hexagonal Music Experiments
// Jacob Peck
// 20101028

import java.util.Scanner;
import org.jfugue.*;
import java.io.File;

public class HexMusicExperiments {
  public static void main(String[] argv) throws Exception {
    Player player = new Player();
    Pattern pattern = new Pattern();
    Scanner sc = new Scanner(System.in);
    System.out.print("Size of the Rule 90 (octave) world: ");
    int size90 = sc.nextInt();
    System.out.print("Size of the Rule 30 (duration) world: ");
    int size30 = sc.nextInt();
    System.out.print("Width of the Peck's Rule (chord) world: ");
    int widthhex = sc.nextInt();
    System.out.print("Height of the Peck's Rule (chord) world: ");
    int heighthex = sc.nextInt();
    System.out.print("7-note scale: ");
    sc.nextLine();
    String scale = sc.nextLine();
    System.out.print("Initializing the worlds....");
    WorldLinearRule90 world90 = new WorldLinearRule90(size90);
    WorldLinearRule30 world30 = new WorldLinearRule30(size30);
    WorldHexChord worldhex = new WorldHexChord(widthhex, heighthex, scale);
    System.out.println("done!");
    System.out.print("Randomizing the worlds....");
    world90.randomizeWorld();
    world30.randomizeWorld();
    worldhex.randomizeWorld();
    System.out.println("done!");
    
    System.out.println("Rule 90 world:");
    world90.print();
    System.out.println("Rule 30 world:");
    world30.print();
    System.out.println("Peck's rule hex world:");
    worldhex.print();
    
    while (true) {
      System.out.println("\n\nHit enter to run the next iteration.\n");
      String line = sc.nextLine();
      if (!line.equals("quit")) {
        world90.iterate();
        world30.iterate();
        worldhex.iterate();
        System.out.println("Rule 90 world:");
        world90.print();
        System.out.println("Rule 30 world:");
        world30.print();
        System.out.println("Peck's rule hex world:");
        worldhex.print();
        System.out.println("Rule 90 mode (octave): " + world90.getMode());
        System.out.println("Rule 30 mode (duration): " + world30.getMode());
        System.out.println("Peck's rule chord: " + worldhex.getChord());
        String musicstring = chordBuilder(worldhex.getChord(), world90.getMode(), world30.getMode());
        System.out.println("MusicString: " + musicstring);
        pattern.add(musicstring);
      } else {
        player.play(pattern);
        player.saveMidi(pattern, new File("dipper.midi"));
        System.exit(0);
      }
    }
  }
  
  public static String chordBuilder(String chord, int octave, double duration) {
    // build JFugue MusicString chord
    String notes[] = chord.split(" ");
    String built = "";
    for (int i = 0; i < notes.length; i++) {
      built = built + "V" + i + " " + notes[i] + octave + "/" + duration + " ";
    }
    return built.trim();
  }
}