// Simple Java Easy Command Line Argument Parser - JEclap
// Written by Jacob Peck/suspended-chord
// version 20101028

import java.util.Scanner;
import java.util.ArrayList;

public class JEclap {
  
  // member variables
  private ArrayList<String> args = new ArrayList<String>();
  
  // constructor
  public JEclap (String[] argv) {
    // initialize ArrayList
    for (String s : argv) {
      args.add(s);
    }
  }
  
  // methods
  
  // hasArg(String arg) [alias function]
  // returns true if -arg is in the list
  // else, returns false
  public boolean hasArg(String arg) {
    return getFlag(arg);
  }
  
  // getAllArgs()
  // return a string of all arguments
  public String getAllArgs() {
    String temp = "";
    for (String s : args) {
      temp = temp + " " + s;
    }
    return temp.trim();
  }
  
  // getArg(String arg)
  // returns the String associated with the -arg, if it exists
  // else, returns null
  public String getArg(String arg) {
    arg = "-" + arg;
    int index = args.indexOf(arg);
    if (index < 0 || args.size() < index+2)
      return null;
    else
      return args.get(index+1);
  }
  
  // getFlag(String arg)
  // returns true if -arg is in the list
  // else, returns false
  public boolean getFlag(String arg) {
    arg = "-" + arg;
    return args.contains(arg);
  }
  
  // getArgDouble(String arg) [alias function]
  // returns an array of two values associated with -arg
  // if non-existant, returns null
  public String[] getArgDouble(String arg) {
    return getArgNTuple(arg, 2);
  }
  
  // getArgNTuple(String arg, int n)
  // returns n elements associated with -arg
  // if non-existant, returns null
  public String[] getArgNTuple(String arg, int n) {
    String[] value = new String[n];
    arg = "-" + arg;
    int index = args.indexOf(arg);
    if (index < 0 || args.size() < index + (n + 1))
      return null;
    else
      for (int i = 0; i < n; i++)
        value[i] = args.get(++index);
    return value;
  }
}