// Rule 90 world
// Jacob Peck
// 20101101

public class WorldLinearRule90 extends WorldLinear {
  
  private int values[] = {3, 4, 5, 6, 7}; // octaves 3-7
  
  public WorldLinearRule90(int dim) {
    super(dim);
    setValues();
  }
  
  public void iterate() {
    for (int i = 0; i < dim; i++) {
      // set history
      oldworld[i].setState(currentworld[i].getState());
    }
    
    for (int i = 0; i < dim; i++) {
      // determine whether cell lives or dies
      int state = oldworld[i].getState();
      int count = oldworld[i].livingNeighbors();
      int newstate = 0;
      
      // rule 90:
      // if cell is alive:
      // alive in next iteration if exactly 0 or 1 neighbor alive
      // dead otherwise
      // if cell is dead:
      // alive in next iteration if exactly 1 or 2 neighbors alive
      // dead otherwise
      switch (state) {
        case 1: // alive
          if (count < 3) newstate = 1;
          break;
        case 0: // dead
          if (count > 0) newstate = 1;
          break;
        default:
          break;
      }
      currentworld[i].setState(newstate);
    }
  }
  
  private void setValues() {
    // rule 90 world is for octaves
    int q = 0;
    for (int i = 0; i < dim; i++) {
      if (q >= values.length) q = 0;
      oldworld[i].setValue(values[q]);
      currentworld[i].setValue(values[q]);
      q++;
    }
  }
  
  public int getMode() { // returns the (first) mode of the set of all the values
    int counts[] = {0,0,0,0,0};
    for (CellLinear c: currentworld) {
      double val = c.getValue();
      int state = c.getState();
      for (int i = 0; i < values.length; i++) {
        if (val == values[i] && state == 1) {
          counts[i]++;
        }
      }
    }
    
    int index = 0;
    for (int i = 0; i < counts.length; i++) {
      if (counts[i] > counts[index]) index = i;
    }
    
    return values[index];
  }
} // end class WorldLinearRule30